#import <UIKit/UIGraphics.h>
#include <stdlib.h>
#include "ShadowView.h"

@implementation ShadowView

-(void) drawRect:(CGRect)rect {
  BOOL shadow = true;
  int iterations = [self getRandomFrom:1 to:50];
  NSLog(@"Drawing %d rectangles", iterations);
  for (int i = 0; i < iterations; ++i) {
    [self drawRandomRect:shadow];
    shadow = !shadow;
  }
}

-(void) drawRandomRect:(BOOL)shadow {
  CGContextRef context = UIGraphicsGetCurrentContext();
  CGContextSaveGState(context);
  
  // generate rectangle
  int width = [self getRandomFrom:10 to:100];
  int height = [self getRandomFrom:10 to:100];
  int screenHeight = (int) self.frame.size.height;
  int screenWidth = (int) self.frame.size.width;
  int x = [self getRandomFrom:0 to:screenWidth - width];
  int y = [self getRandomFrom:0 to:screenHeight - height];
  CGRect rectangle = CGRectMake(x, y, width, height);
  
  // set color
  float red = [self getRandomFloatFrom:0 to:1];
  float green = [self getRandomFloatFrom:0 to:1];
  float blue = [self getRandomFloatFrom:0 to:1];
  CGContextSetRGBFillColor(context, red, green, blue, 1.0);
  CGContextSetRGBStrokeColor(context, red, green, blue, 1.0);
  
  //set shadow
  if (shadow) {
    CGContextSetShadow(context, CGSizeMake(5, 5), 1.0);
  }
  
  // draw rectangle
  CGContextFillRect(context, rectangle);
  CGContextRestoreGState(context);
}

-(int) getRandomFrom:(int)lower to:(int)upper {
  return lower + arc4random_uniform(upper - lower);
}

-(float) getRandomFloatFrom:(float)lower to:(float)upper {
  return lower + ((arc4random() % RAND_MAX) / (RAND_MAX * 1.0)) * (upper - lower);
}

@end
